<template>
  <Row class="manager-personal-index">
    <i-col class="step-block content-block" :span="8">
      <Row class="image-block">
        <Upload action=""
                :show-upload-list="false"
                :before-upload="getUploadImageAction">
          <div class="user-image-back-circle">
            <div class="user-image" :style="{backgroundImage}"></div>
          </div>
        </Upload>
      </Row>
      <Row class="step-list">
        <div class="steps">
          <div v-for="(step, index) in steps" :key="index" class="step-item"
               :ref="step.key" @click="showStepFormAction(step.key)">
            <div class="dot" :style="dotStyle(step.key)"></div>
            <div class="label">{{step.label}}</div>
          </div>
        </div>
        <Row class="btn-block">
          <template v-if="formToShow(0) && !edit">
            <button class="literal-div-btn edit-btn" @click="editBasicFormAction">Edit</button>
          </template>
          <template v-if="formToShow(0) && edit">
            <button class="literal-div-btn cancel-btn" @click="cancelEditFormAction">Cancel</button>
            <button class="literal-div-btn update-btn" @click="updateBasicInfoAction">Update</button>
          </template>

          <template v-if="formToShow(2)">
            <button class="literal-div-btn reset-psw-btn" @click="resetPasswordFormAction">Cancel</button>
            <button class="literal-div-btn update-psw-btn" @click="updatePasswordAction">Update</button>
          </template>

          <template v-if="formToShow(3)">
            <button class="literal-div-btn reset-remove-account-btn" @click="resetRemoveFormAction">Cancel</button>
            <button class="literal-div-btn remove-account-btn" @click="removeAccountAction">Remove</button>
          </template>
        </Row>
      </Row>
    </i-col>
    <i-col class="form-block content-block" :span="16">
      <!-- Basic Information -->
      <stock-form v-show="formToShow(0)" title="Basic Information">
        <stock-form-item v-for="(field, index) in schemaFields(basicInfoForm.schema)" :key="field"
                         v-model="basicInfoForm.data[field]"
                         :options="basicInfoForm.schema[field]"
                         :error="basicInfoForm.error[field]"
                         :edit="toEdit(field)">
        </stock-form-item>
      </stock-form>

      <!-- Role Type -->
      <stock-form v-show="formToShow(1)" title="Role Type">
        <Row>
          <i-col class="role-block" :lg="12" :md="12">
            <div class="role-item checked">
              <div class="manager-btn div-btn">
                <Icon type="md-settings"></Icon>
              </div>
              <div> Manager </div>
            </div>
          </i-col>

          <i-col class="role-block" :lg="12" :md="12">
            <div class="role-item">
              <div class="user-btn div-btn">
                <Icon type="md-person"></Icon>
              </div>
              <div> User </div>
            </div>
          </i-col>
        </Row>
      </stock-form>

      <!-- Reset Password -->
      <stock-form v-show="formToShow(2)" title="Reset Password">
        <stock-form-item v-for="(field, index) in schemaFields(resetPasswordForm.schema)" :key="`${formKey}-${field}`"
                         v-model="resetPasswordForm.data[field]"
                         :options="resetPasswordForm.schema[field]"
                         :error="resetPasswordForm.error[field]"
                         :edit="true">
        </stock-form-item>
      </stock-form>

      <!-- Remove Account -->
      <stock-form v-show="formToShow(3)" title="Remove Account">
        <stock-form-item v-for="(field, index) in schemaFields(removeAccountForm.schema)" :key="field"
                         v-model="removeAccountForm.data[field]"
                         :options="removeAccountForm.schema[field]"
                         :edit="true">
        </stock-form-item>
      </stock-form>

    </i-col>
  </Row>
</template>

<script>
import StockFormItem from "../../../components/StockFormItem";
import * as form from '../../../helpers/form';
import StockForm from '../../../components/StockForm';
import { apiRoot } from '../../../configs/api';
import { mapActions } from 'vuex';
import { validators as api } from '../../../configs/request-validator/user';

const actions = {
  async getUploadImageAction(file) {
    if (file) {
      const reader = new FileReader();
      reader.onload = () => {
        this.profileImageURL = reader.result;
      };
      reader.readAsDataURL(file);
      this.profileImageFile = file;

      try {
        const requestData = { userId: null, image: file };
        await this.$api(api.UpdateUserImageRequest, requestData);
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  },
  showStepFormAction(currentStepKey) {
    this.currentStep = currentStepKey;
  },
  editBasicFormAction() {
    this.edit = true;
  },
  cancelEditFormAction() {
    this.edit = false;
    Object.keys(this.basicInfoCopyData).forEach(key => {
      this.basicInfoForm.data[key] = this.basicInfoCopyData[key];
    });
    this.basicInfoCopyData = undefined;
  },
  async updateBasicInfoAction() {
    try {
      const requestData = {
        ...this.basicInfoForm.data,
        userId: this.userId,
      };
      const { data } = await this.$api(api.UpdateUserRequest, requestData);
      this.setUser(data);
      this.edit = false;
    } catch (error) {
      this.basicInfoForm.error = this.$apiErrorHandler(error) || {};
    }
  },
  resetPasswordFormAction() {
    this.resetPasswordForm.data.originPassword = undefined;
    this.resetPasswordForm.data.newPassword = undefined;
    this.resetPasswordForm.data.newPassword_confirmation = undefined;
    this.$refs[0][0].click();
  },
  async updatePasswordAction() {
    try {
      const requestData = this.resetPasswordForm.data;
      const { status, code } = await this.$api(api.UpdatePasswordRequest, requestData);
      const updateSuccess = status && code === 200;
      if (updateSuccess) {
        this.$Notice.success({ title: 'Password is updated' });
        setTimeout(() => {
          this.$router.go(0);
        }, 3000);
      }
    } catch (error) {
      this.resetPasswordForm.error = this.$apiErrorHandler(error) || {};
    }
  },
  resetRemoveFormAction() {
    this.removeAccountForm.data.email = undefined;
    this.removeAccountForm.data.password = undefined;
    this.$refs[0][0].click();
  },
  async removeAccountAction() {
    try {
        const requestData = this.removeAccountForm.data;
        const { status, code } = await this.$api(api.RemoveUserRequest, requestData);
        const removeSuccess = status && code === 200;
        if (removeSuccess) {
          this.$redirectTo('index');
        }
    } catch (error) {
      this.removeAccountForm.error = this.$apiErrorHandler(error) || {};
    }
  },
};

export default {
  name: 'index',
  mixins: [form.mixin],
  components: { StockForm, StockFormItem},
  data() {
    return {
      profileImageURL: undefined,
      profileImageFile: undefined,
      steps: [
        { key: 0, label: 'Basic Information' },
        { key: 1, label: 'Role Type' },
        { key: 2, label: 'Change Password' },
        { key: 3, label: 'Remove Account' },
      ],
      currentStep: 0,
      // form
      userId: null,
      edit: false,
      basicInfoForm: undefined,
      resetPasswordForm: undefined,
      removeAccountForm: undefined,
      basicInfoCopyData: undefined,
      formKey: (new Date()).getTime(),
    };
  },
  computed: {
    backgroundImage() {
      return `url(${this.profileImageURL})`;
    }
  },
  watch: {
    edit() {
      if (this.edit) {
        this.basicInfoCopyData = { ...this.basicInfoForm.data };
      }
    },
    ['basicInfoForm.data']() {
      this.formKey = (new Date()).getTime();
    },
    ['resetPasswordForm.data']() {
      this.formKey = (new Date()).getTime();
    },
    ['basicInfoCopyData']() {
      this.formKey = (new Date()).getTime();
    },
  },
  methods: {
    ...mapActions('user', ['setUser']),
    ...actions,
    dotStyle(key) {
      const isCurrentStep = this.currentStep === key;
      return (isCurrentStep)
        ? {
          width: '20px',
          height: '20px',
          borderRadius: '11px',
          left: '-26px',
          top: '12px',
          backgroundColor: '#3de1ff',
        }
        : {};
    },
    formToShow(key) {
      return this.currentStep === key;
    },
    toEdit(field) {
      const hasEditProp = this.basicInfoForm.schema[field].hasOwnProperty('edit');
      const edit = this.basicInfoForm.schema[field]['edit'];
      return (hasEditProp) ? edit : this.edit;
    },
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({ store }) {
    const loginUser = { ...store.getters['user/user'] };

    const basicInfoForm = {
      ...form.basicForm,
      schema: {
        name: { type: 'text', title: 'Account' },
        email: { type: 'text', title: 'Email' },
        phone: { type: 'text', title: 'Phone Number' },
        createdAt: { type: 'text', title: 'Join At', edit: false },
      },
      rules: api.UpdateUserRequest.body,
      data: loginUser,
    };

    const resetPasswordForm = {
      ...form.basicForm,
      schema: {
        originPassword: { type: 'password', title: 'Original Password' },
        newPassword: { type: 'password', title: 'New Password' },
        newPassword_confirmation: { type: 'password', title: 'Confirm Password' },
      },
      rules: {
        ...api.UpdatePasswordRequest.body,
        newPassword_confirmation: 'required|string',
      },
      data: {
        originPassword: undefined,
        newPassword: undefined,
        newPassword_confirmation: undefined,
      },
    };

    const removeAccountForm = {
      ...form.basicForm,
      schema: {
        email: { type: 'text', title: 'Email' },
        password: { type: 'password', title: 'Password' },
      },
      rules: {
        ...api.RemoveUserRequest.body,
        "email": "required|string|email|exists:users,email",
      },
      data: {
        email: undefined,
        password: undefined,
      },
    };

    return {
      userId: loginUser['id'],
      profileImageURL: loginUser['image']
        ? loginUser['image']
        : 'https://i.ytimg.com/vi/s7_2vC7BoCs/maxresdefault.jpg',
      basicInfoForm,
      resetPasswordForm,
      removeAccountForm,
    };
  },
}
</script>

<style lang="scss" scoped>
  @import '../../../assets/css/mixin';

  .manager-personal-index {
    height: 100%;
    .content-block {
      height: 100%;
      overflow-y: auto;
    }
    .step-block {
      height: 100%;
      overflow: hidden;
      &::before {
        content: "";
        position: absolute;
        width: 100%;
        height: 100%;
        top: 3%;
        right: -28%;
        z-index: -1;
        background: url("/images/horn-background.png") 0 0 no-repeat;
        background-size: contain;
        transform: rotate(-23deg);
      }
      .image-block {
        position: relative;
        top: 10%;
        text-align: center;
        cursor: pointer;
        .user-image-back-circle {
          position: relative;
          width: 130px;
          height: 130px;
          padding: 5px;
          border-radius: 71px;
          text-align: center;
          .user-image {
            width: 120px;
            height: 120px;
            border-radius: 61px;
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
          }
        }
      }
      .step-list {
        position: relative;
        top: 15%;
        text-align: center;
        text-align: -webkit-center;
        .steps {
          .step-item {
            text-align: left;
            width: 190px;
            height: 50px;
            padding: 10px 15px;
            line-height: 30px;
            vertical-align: middle;
            font-size: 16px;
            font-weight: bold;
            cursor: pointer;
            .dot {
              position: relative;
              top: 10px;
              left: -24px;
              width: 16px;
              height: 16px;
              border-radius: 9px;
            }
            .label {
              position: relative;
              top: -12px;
              margin-left: 10px;
            }
          }
        }
        .btn-block {
          margin: 60px 0;
        }
      }
    }
    .form-block {
      padding: 80px 10%;
      .role-block {
        text-align: center;
        .role-item {
          width: 60%;
          padding: 10px 15px;
          margin: 0 20%;
          .manager-btn {
            @include circle-div-btn(60);
          }
          .user-btn {
            @include circle-div-btn(60);
          }
        }
        .role-item.checked {
          border-radius: 6px;
        }
      }
    }
  }
</style>
